//+------------------------------------------------------------------+
//|                                                                  |
//| "Fixing the Bollinger bands"                                     |
//| Futures magazine 05.2010, David Rooke                            |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Yellow//DeepSkyBlue 
#property indicator_color2  Yellow//PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern int    Length                 = 20;//120 
extern int    Price                  = PRICE_CLOSE;
extern double Deviations             = 2.0;
extern bool   UseClassicalDeviations = false; 
extern double LevelUp                = 1.0;//*************** NB
extern double LevelDown              = 0.0;//*************** NB

//
//
//
//
//

double vbp[];
double vbc[];
double vbu[];
double vbd[];
double prices[];
double arrowUp[];
double arrowDn[];
double state[];

//+-------------------------------------------------------------------------------------+
//|                                                                                     |
//+-------------------------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0, arrowUp); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,221);//241//181
      SetIndexBuffer(1, arrowDn); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,222);//242>>181
      SetIndexBuffer(2, vbp); 
      SetIndexBuffer(3, vbc); 
      SetIndexBuffer(4, vbu); 
      SetIndexBuffer(5, vbd); 
      SetIndexBuffer(6, prices); 
      SetIndexBuffer(7, state); 
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      prices[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);

         double tema1 = iTema(prices[i],Length,i,0);
         double tema2 = iTema(tema1    ,Length,i,3);

      vbc[i] = 2.0*tema1-tema2;

         double deviation = iDeviationPlus(prices,vbc,Length,i);

      vbu[i] = vbc[i]+deviation*Deviations;
      vbd[i] = vbc[i]-deviation*Deviations;

         double width = vbu[i]-vbd[i];

      if (width>0)
           vbp[i] = (prices[i]-vbd[i])/width;
      else vbp[i] = 0;               
      
      //
      //
      //
      //
      //
      
      arrowUp[i] = EMPTY_VALUE;
      arrowDn[i] = EMPTY_VALUE;
      state[i]   = state[i+1];
         if (vbp[i]> LevelUp)   state[i] =  1;
         if (vbp[i]< LevelDown) state[i] = -1;
         if (state[i] != state[i+1])
            if (state[i]==1)
                  arrowUp[i] = High[i] + iATR(NULL,0,20,i)/2.0;
            else  arrowDn[i] = Low [i] - iATR(NULL,0,20,i)/2.0;
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrk[][6];

double iTema(double price, int length, int i, int s=0)
{
   if (ArrayRange(wrk,0)!=Bars) ArrayResize(wrk,Bars);
   
   //
   //
   //
   //
   //
   
   double alpha = 2.0 /(1.0 + length);
   int    r = Bars-i-1;
   
   if (r < 1)
      {
         wrk[r][0+s] = price;
         wrk[r][1+s] = price;
         wrk[r][2+s] = price;
      }
   else
      {
         wrk[r][0+s] = wrk[r-1][0+s]+alpha*(price      -wrk[r-1][0+s]);
         wrk[r][1+s] = wrk[r-1][1+s]+alpha*(wrk[r][0+s]-wrk[r-1][1+s]);
         wrk[r][2+s] = wrk[r-1][2+s]+alpha*(wrk[r][1+s]-wrk[r-1][2+s]);
      }
   return(3*wrk[r][0+s] - 3*wrk[r][1+s] + wrk[r][2+s]);
}

//
//
//
//    In the original article the second method is how deviation is
//    calculated . It is a questionableble method , but if we apply
//    standard calculation the bands tend to be "spiky".That is the
//    reason to have the "UseClassicalDeviations" option
//
//
//

double iDeviationPlus(double& array[], double& ma[], int period, int i)
{
   double sum = 0;
      if (UseClassicalDeviations)
            for(int k=0; k<period; k++) sum += (array[i+k]-ma[i])  *(array[i+k]-ma[i]);
      else  for(    k=0; k<period; k++) sum += (array[i+k]-ma[i+k])*(array[i+k]-ma[i+k]);       
   return(MathSqrt(sum/period));
}

//===========================================================================================+